diff --git a/guix/import/utils.scm b/guix/import/utils.scm
index 9cadbb3d5f..646921c73b 100644
--- a/guix/import/utils.scm
+++ b/guix/import/utils.scm
@@ -132,7 +132,7 @@ (define (spdx-string->license str)
   "Convert STR, a SPDX formatted license identifier, to a license object.
    Return #f if STR does not match any known identifiers."
   ;; https://spdx.org/licenses/
-  ;; The psfl, gfl1.0, nmap, repoze
+  ;; The gfl1.0, nmap, repoze
   ;; licenses doesn't have SPDX identifiers
   ;;
   ;; Please update guix/licenses.scm when modifying
@@ -143,14 +143,17 @@ (define (spdx-string->license str)
     ;; or "GPL-N-or-later" as appropriate.  Likewise for LGPL
     ;; and AGPL
     ("AGPL-1.0"                    'license:agpl1)
+    ("AGPL-1.0-only"               'license:agpl1)
     ("AGPL-3.0"                    'license:agpl3)
     ("AGPL-3.0-only"               'license:agpl3)
     ("AGPL-3.0-or-later"           'license:agpl3+)
     ("Apache-1.1"                  'license:asl1.1)
     ("Apache-2.0"                  'license:asl2.0)
+    ("APSL-2.0"                    'license:apsl2)
     ("BSL-1.0"                     'license:boost1.0)
     ("0BSD"                        'license:bsd-0)
-    ("BSD-2-Clause-FreeBSD"        'license:bsd-2)
+    ("BSD-2-Clause"                'license:bsd-2)
+    ("BSD-2-Clause-FreeBSD"        'license:bsd-2)     ;flagged as deprecated on spdx
     ("BSD-3-Clause"                'license:bsd-3)
     ("BSD-4-Clause"                'license:bsd-4)
     ("CC0-1.0"                     'license:cc0)
@@ -161,17 +164,29 @@ (define (spdx-string->license str)
     ("CC-BY-SA-3.0"                'license:cc-by-sa3.0)
     ("CC-BY-SA-4.0"                'license:cc-by-sa4.0)
     ("CDDL-1.0"                    'license:cddl1.0)
+    ("CDDL-1.1"                    'license:cddl1.1)
+    ("CECILL-2.1"                  'license:cecill)
+    ("CECILL-B"                    'license:cecill-b)
     ("CECILL-C"                    'license:cecill-c)
     ("Artistic-2.0"                'license:artistic2.0)
     ("ClArtistic"                  'license:clarified-artistic)
+    ("copyleft-next-0.3.0"         'license:copyleft-next)
     ("CPL-1.0"                     'license:cpl1.0)
     ("EPL-1.0"                     'license:epl1.0)
+    ("EPL-2.0"                     'license:epl2.0)
+    ("EUPL-1.2"                    'license:eupl1.2)
     ("MIT"                         'license:expat)
     ("FTL"                         'license:freetype)
+    ("FreeBSD-DOC"                 'license:freebsd-doc)
     ("Freetype"                    'license:freetype)
+    ("FSFAP"                       'license:fsf-free)
+    ("FSFUL"                       'license:fsf-free)
     ("GFDL-1.1"                    'license:fdl1.1+)
+    ("GFDL-1.1-or-later"           'license:fdl1.1+)
     ("GFDL-1.2"                    'license:fdl1.2+)
+    ("GFDL-1.2-or-later"           'license:fdl1.2+)
     ("GFDL-1.3"                    'license:fdl1.3+)
+    ("GFDL-1.3-or-later"           'license:fdl1.3+)
     ("Giftware"                    'license:giftware)
     ("GPL-1.0"                     'license:gpl1)
     ("GPL-1.0-only"                'license:gpl1)
@@ -204,14 +219,24 @@ (define (spdx-string->license str)
     ("LGPL-3.0-only"               'license:lgpl3)
     ("LGPL-3.0+"                   'license:lgpl3+)
     ("LGPL-3.0-or-later"           'license:lgpl3+)
+    ("LPPL-1.0"                    'license:lppl)
+    ("LPPL-1.1"                    'license:lppl)
+    ("LPPL-1.2"                    'license:lppl1.2)
+    ("LPPL-1.3a"                   'license:lppl1.3a)
+    ("LPPL-1.3c"                   'license:lppl1.3c)
+    ("MirOS"                       'license:miros)
     ("MPL-1.0"                     'license:mpl1.0)
     ("MPL-1.1"                     'license:mpl1.1)
     ("MPL-2.0"                     'license:mpl2.0)
     ("MS-PL"                       'license:ms-pl)
     ("NCSA"                        'license:ncsa)
+    ("OGL-UK-1.0"                  'license:ogl-psi1.0)
     ("OpenSSL"                     'license:openssl)
     ("OLDAP-2.8"                   'license:openldap2.8)
+    ("OPL-1.0"                     'license:opl1.0+)
     ("CUA-OPL-1.0"                 'license:cua-opl1.0)
+    ("PSF-2.0"                     'license:psfl)
+    ("OSL-2.1"                     'license:osl2.1)
     ("QPL-1.0"                     'license:qpl)
     ("Ruby"                        'license:ruby)
     ("SGI-B-2.0"                   'license:sgifreeb2.0)
@@ -220,6 +245,9 @@ (define (spdx-string->license str)
     ("TCL"                         'license:tcl/tk)
     ("Unlicense"                   'license:unlicense)
     ("Vim"                         'license:vim)
+    ("W3C"                         'license:w3c)
+    ("WTFPL"                       'license:wtfpl2)
+    ("wxWindow"                    'license:wxwindows3.1+)         ;flagged as deprecated on spdx
     ("X11"                         'license:x11)
     ("ZPL-2.1"                     'license:zpl2.1)
     ("Zlib"                        'license:zlib)